{
  outputs = { self, nixpkgs }: {
    # miscellaneous stuff that's important 
    nixosModules.base = {lib, ...}: {
      boot.swraid.enable = lib.mkForce false;
      networking.hostName = "chopper";
      networking.firewall.enable = true;
      system.stateVersion = "24.05";
      sdImage.firmwarePartitionOffset = 32;
    };
    # Configuration of individual users
    nixosModules.users = {...}: {
      users.users.taneb = {
        isNormalUser = true;
        extraGroups = [ "wheel" ];
        openssh.authorizedKeys.keys = [
          "ssh-ed25519 AAAAC3NzaC1lZDI1NTE5AAAAIIV9ymP4tpq11a8wfUvn8eEEwAPvZZSPZTbASLh7YxOw nvd1234@gmail.com"
        ];
        hashedPassword = "$y$j9T$9pxQ4Zj7OirGMmgclhUb0/$YCfaYmIaaHRrkqiqdNbQSlJ7puX8bGrMCLavq6Pe1e3";
      };
      users.mutableUsers = false;
    };
    # Configuration of SSH server
    nixosModules.ssh = {...}: {
      services.openssh = {
        enable = true;
        openFirewall = true;
        settings.PasswordAuthentication = false;
      };
    };
    nixosConfigurations.chopper = nixpkgs.lib.nixosSystem {
      system = "aarch64-linux";
      modules = [
        (nixpkgs + "/nixos/modules/installer/sd-card/sd-image-aarch64.nix")
        self.nixosModules.base
        self.nixosModules.users
        self.nixosModules.ssh
      ];
    };
  };
}
